var appPage = "reward-page";
var nativeAdIds = [];
$(function () {

    //=======================================================
   // pages manager
    //=======================================================

   $(".page-navigator a").click(function () {
        var page = $(this).data('page');
        if(page == 'reward-page'){
            appPage = 'reward-page';
            if(FacebookAds) FacebookAds.createNativeAd('');
            if(appPage in nativeAdIds){
                updateClickArea(nativeAdIds[appPage],'nativead-main');
            }
            rewardPageReset();
        }else if(page == 'add-reward-page'){
            appPage = 'add-reward-page';
            // facebook native ads
            if(FacebookAds) FacebookAds.createNativeAd('');
            if(appPage in nativeAdIds){
                updateClickArea(nativeAdIds[appPage],'nativead-new-reward');
            }
            $('#ajax-response2').html('');
        }else if(page == 'about-page'){
            appPage = 'about-page';
            
            getRewards(function (r) {
                var counter = 1;
                $(r).each(function(i,v){
                    var html="";
                        html += "<div class=\"mdl-list__item\">";
                        html += "                    <div class=\"mdl-list__item-primary-content\">";
                        html += "                      <p style=\"width: 100%;\">Code: "+v.ecode+"<br \/>";
                        if(v.ctype == 1){
                            html += "Coins : "+v.cvalue+"<\/p>";
                        }else{
                            html += "Item : "+v.citem+"<\/p>";
                        }
                        html += "                    <\/div>";
                        html += "                    <button onclick=\"applyCode(this,'"+v.code+"')\" class=\"mdl-list__item-secondary-action mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect mdl-button--colored\">";
                        html += "                        Apply";
                        html += "                    <\/button>";
                        html += "                  <\/div>";
                        if(counter == 6){
                            html += "<div id='nativead-list-page'></div>";
                        }
                        $(".available-rewards").append(html);
                        if(counter == 6){
                            if(FacebookAds) FacebookAds.createNativeAd('');                                                    
                        }
                        counter++;
                });
                $("#rewards-list-loader").addClass('hidden');
            },function(){
                $(".available-rewards").html('');
                $("#rewards-list-loader").removeClass('hidden');
            },function(httpRequest){
                $("#rewards-list-loader").addClass('hidden');
                if(httpRequest.status == 0){
                    $(".available-rewards").html('<div class="bg-light-red pad-5">'+response_text('Please make sure you are connected to the internet')+'</div>');
                }else{
                    $(".available-rewards").html('<div class="bg-light-red pad-5">'+response_text('Server is too busy to respond try again!')+'</div>');
                }
            });
            
        }else if(page == 'exit-app'){
            navigator.app.exitApp();
            return false;
        }else{
            
        }

        $('.page-active').removeClass('page-active');
        $("."+page).addClass('page-active');
     $(this).parents('.mdl-layout__drawer:first').removeClass('is-visible');
        $(".mdl-layout__obfuscator").removeClass('is-visible');
    });

    //=======================================================
   // claim rewards
    //=======================================================

   $("#claim-rewards").click(function () {
       var uniqueID = $("#miniclip-uniqueID").val();
       if(uniqueID.length <= 0){
           alert('Please enter your Unique ID!');
           return false;
       }
       if($.isNumeric(uniqueID) === false){
           alert('Please enter only numbers');
           return false;
       }
       setUniqueID(uniqueID);
       $(this).next().removeClass('hidden');
       $(this).attr('disabled','true');
       $(".bar-loader").fadeIn();
       
       connect(function () {
           getRewards(function (r) {
               applyCodes(uniqueID,r);
           });
       });
   });
   
    //=======================================================
   // add new reward code
    //=======================================================

   $("#claim-new-reward").click(function () {
       var uniqueID = $("#miniclip-uniqueID-new").val();
       var code = $("#miniclip-rewardCode").val();
       if(uniqueID.length <= 0){
           alert('Please enter your Unique ID!');
           return false;
       }
       if($.isNumeric(uniqueID) === false){
           alert('Please enter only numbers');
           return false;
       }
       if(code.length <= 0){
           alert('Please enter reward code!');
           return false;
       }
       
       setUniqueID(uniqueID);
       $(this).next().removeClass('hidden');
       $(this).attr('disabled','true');
       $(".new-bar-loader").fadeIn();

       callAPI('add-reward',function () {
           response(response_text('Please wait . . .'),'#ajax-response2');
       },function (r) {
           delay(function () {
               if(r.type == 'error'){
                   response('<div class="bg-light-red pad-5">'+response_text(r.message)+'</div>','#ajax-response2');
               }else{
                   var html="";
                   html += "";
                   html += "                            <button class=\"mdl-button mdl-js-button mdl-button--fab button-success\">";
                   html += "                            <i class=\"fa fa-hand-peace-o\" aria-hidden=\"true\"></i>";
                   html += "                            <\/button>";
                   html += "                            <div class=\"success\">";
                   html += "                            <h1>well done !<\/h1>";
                   html += "                            <p>"+r.message+"<\/p>";
                   html += "                            <\/div>";
                   response(html,'#ajax-response2');
                   $("#miniclip-uniqueID-new").val('');
                   $("#miniclip-rewardCode").val('');
                   
                   var admobid2 = {
                      interstitial: 'ca-app-pub-6746517942956278/9443924549'
                   };
                    if(AdMob) AdMob.prepareInterstitial( {adId:admobid2.interstitial, autoShow:true} );
                   
               }
               $("#new-reward-btn-spinner").addClass('hidden');
               $(".new-bar-loader").fadeOut();
               $("#claim-new-reward").removeAttr('disabled');
           },1000);
       },function(httpRequest){
            if(httpRequest.status != 0){
                response('<div class="bg-light-red pad-5">'+response_text('Server is too busy to respond try again!')+'</div>','#ajax-response2');
                alert('Server is too busy to respond try again!');
            }else{
                response('','#ajax-response2');
            }
            $("#new-reward-btn-spinner").addClass('hidden');
            $(".new-bar-loader").fadeOut();
            $("#claim-new-reward").removeAttr('disabled');
       },'POST',{uniqueid: uniqueID,code: code});
   });

});

var app = {
    initialize: function() {
        this.bindEvents();
    },
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
        //setInterval(function(){
//            if(navigator.onLine==false){
//                alert('This application requires internet. Please connect to the internet.');
//                navigator.app.exitApp();
//            }
//        },100);
    }
    ,
    onDeviceReady: function() {
        var storageUniqueID = localStorage.getItem('uniqueId');
        if(storageUniqueID){
            $("#miniclip-uniqueID-new").val(storageUniqueID).parent().addClass('is-focused');
            $("#miniclip-uniqueID-list").val(storageUniqueID).parent().addClass('is-focused');
            $("#miniclip-uniqueID").val(storageUniqueID).parent().addClass('is-focused');
        }
        checkConnection();
        $(".mdl-layout__drawer-button").html('<i class="fa fa-bars" aria-hidden="true"></i>');
        var admobid = {
          banner: 'ca-app-pub-6746517942956278/7967191346', // or DFP format "/6253334/dfp_example_ad"
          interstitial: 'ca-app-pub-6746517942956278/9443924549'
        };
        
        if(AdMob) AdMob.createBanner({
          adId: admobid.banner,
          adSize: 'SMART_BANNER',
          position: AdMob.AD_POSITION.BOTTOM_CENTER,
          autoShow: true,
          overlap: false,
          offsetTopBar: false,
          bgColor: 'black'
        });
        
        // preppare and load ad resource in background, e.g. at begining of game level
        if(AdMob) AdMob.prepareInterstitial( {adId:admobid.interstitial, autoShow:true} );
        //if(FacebookAds){
//            FacebookAds.setOptions({
//            	isTesting: true,
//            	deviceHash: '7153ca9a2d963d50'
//            });
//        }
        
        
        
        
        // facebook native ads
        
        if(FacebookAds) FacebookAds.createNativeAd('');
        
		document.addEventListener('onAdLoaded',function(data) {
			if (data.adType == "native") {
				var adRes = data.adRes;
				//alert( JSON.stringify(adRes) );
		
				// show ad
				nativeId = data.adId;
				if(appPage == 'reward-page'){
				    nativeAdIds['reward-page'] = data.adId;
                    $('#nativead-main').html(nativeAdHtml(adRes));
				    updateClickArea(data.adId,'nativead-main');
                }else if(appPage == 'add-reward-page'){
                    nativeAdIds['add-reward-page'] = data.adId;
                    $('#nativead-new-reward').html(nativeAdHtml(adRes));
                    updateClickArea(data.adId,'nativead-new-reward');
                }else if(appPage == 'about-page'){
                    nativeAdIds['about-page'] = data.adId;
                    $('#nativead-list-page').html(nativeAdHtmlList(adRes));
                    updateClickArea(data.adId,'nativead-list-page');
                }
			}
        });
        
        $('.mdl-layout__drawer-button').click(function(){
            if(appPage in nativeAdIds){
                if(FacebookAds) FacebookAds.setNativeAdClickArea(nativeAdIds[appPage],0,0,0,0);
            }
        });
                
        $('.mdl-layout__content').scroll(function(){
            var AdId = false;
            
            if(appPage == 'reward-page' && ('reward-page' in nativeAdIds)){
                AdId = nativeAdIds['reward-page'];
                updateClickArea(AdId,'nativead-main');
            }
            else if(appPage == 'add-reward-page' && ('add-reward-page' in nativeAdIds)){
                AdId = nativeAdIds['add-reward-page'];
                updateClickArea(AdId,'nativead-new-reward');
            }
            else if(appPage == 'about-page' && ('about-page' in nativeAdIds)){
                AdId = nativeAdIds['about-page'];
                updateClickArea(AdId,'nativead-list-page');
            }
            else{
                
            }
		});
        

        $(document).on('backbutton', function(){
            if(window.confirm('Are you sure to quit?')) navigator.app.exitApp();
        });

        $(document).on('resume', function(){
            AdMob.showInterstitial();
        });

        app.setupPush();
    },
    setupPush: function() {
        var push = PushNotification.init({
            "android": {
                "senderID": "1073517974085"
            },
            "browser": {},
            "ios": {
                "sound": true,
                "vibration": true,
                "badge": true
            },
            "windows": {}
        });
        push.on('registration', function(data) {
            var oldRegId = localStorage.getItem('registrationId');
            if (oldRegId !== data.registrationId) {
                localStorage.setItem('registrationId', data.registrationId);
            }
        });
        
        push.subscribe('new-reward', function() {
        	//console.log('success');
        }, function(e) {
        	//console.log('error:');
        });

        push.on('error', function(e) {

        });

        push.on('notification', function(data) {
            navigator.notification.alert(
                data.message,         // message
                null,                 // callback
                data.title,           // title
                'Ok'                  // buttonName
            );
            navigator.notification.beep(1);
            navigator.notification.vibrate(2000);
       });
    }
};
